"""add DAs and AODs to db

Revision ID: 53b0c9f115f8
Revises: 702a4a776f9b
Create Date: 2022-01-24 13:05:18.476190

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "53b0c9f115f8"
down_revision = "702a4a776f9b"
branch_labels = None
depends_on = None


def upgrade():
    op.create_table(
        "qa_staff",
        sa.Column(
            "user_name",
            sa.String,
            primary_key=True,
            comment="The user name of the staff member performing QA.",
        ),
        sa.Column(
            "group",
            sa.String,
            comment="Is this staff member a DA or an AOD?",
        ),
        sa.Column(
            "available",
            sa.Boolean,
            default=True,
            comment="Is this staff member available to be assigned QA jobs?",
        ),
        comment="List of people capable of performing QA and their availability",
    )

    op.execute(
        """
        ALTER TABLE capability_requests
        ADD COLUMN assigned_da varchar 
        """
    )

    op.execute(
        """
        ALTER TABLE capability_requests
        ADD COLUMN assigned_aod varchar
        """
    )


def downgrade():
    op.drop_table("qa_staff")
    op.execute(
        """
        ALTER TABLE capability_requests DROP COLUMN IF EXISTS assigned_da
        """
    )
    op.execute(
        """
        ALTER TABLE capability_requests DROP COLUMN IF EXISTS assigned_aod
        """
    )
